{***************************************************************************}
{                           UNIDAD DE DOS SERVICES

                                  Copyright (c) 1998 Marco Antonio Alvarado
}
{***************************************************************************}

UNIT UDS;

INTERFACE

  TYPE

    RInformacionDisco = RECORD
      Nivel : Word;
      Serie : LongInt;
      Etiqueta : ARRAY [0..10] OF Char;
      Sistema : ARRAY [0..7] OF Char;
    END;

  VAR
{Errores:
  1 = la versin de DOS no es 4.0 o superior.}
    Error,
    VersionMayor,
    VersionMenor : Byte;

  PROCEDURE TomaVersion (VAR Mayor, Menor : Byte);
  FUNCTION TomaInformacionDisco (Disco : Byte; VAR Informacion :
    RInformacionDisco) : Boolean;
  FUNCTION PoneInformacionDisco (Disco : Byte; VAR Informacion :
    RInformacionDisco) : Boolean;
  FUNCTION TomaInterrupcion (Indice : Byte) : Pointer;
  PROCEDURE PoneInterrupcion (Indice : Byte; Direccion : Pointer);

IMPLEMENTATION

  CONST
    InterrupcionDOS = $21;
    FuncionTomaVersion = $30;
    FuncionInformacionDisco = $69;
    FuncionTomaInformacionDisco = $00;
    FuncionPoneInformacionDisco = $01;
    FuncionPoneInterrupcion = $25;
    FuncionTomaInterrupcion = $35;

  PROCEDURE TomaVersion (VAR Mayor, Menor : Byte); ASSEMBLER;
  ASM
    MOV AH, FuncionTomaVersion
    INT InterrupcionDOS
    LES DI, Mayor
    MOV ES:Byte Ptr [DI], AL
    LES DI, Menor
    MOV ES:Byte Ptr [DI], AH
  END;

  FUNCTION TomaInformacionDisco (Disco : Byte; VAR Informacion :
    RInformacionDisco) : Boolean; ASSEMBLER;

    LABEL
      Error, Fin;

  ASM
    MOV AH, FuncionInformacionDisco
    MOV AL, FuncionTomaInformacionDisco
    MOV BL, Disco
    PUSH DS
    LDS DX, Informacion
    INT InterrupcionDOS
    POP DS
    JC Error
    MOV AL, True
    JMP Fin

    Error:

    MOV AL, False

    Fin:

  END;

  FUNCTION PoneInformacionDisco (Disco : Byte; VAR Informacion :
    RInformacionDisco) : Boolean; ASSEMBLER;

    LABEL
      Error, Fin;

  ASM
    MOV AH, FuncionInformacionDisco
    MOV AL, FuncionPoneInformacionDisco
    MOV BL, Disco
    PUSH DS
    LDS DX, Informacion
    INT InterrupcionDOS
    POP DS
    JC Error
    MOV AL, True
    JMP Fin

    Error:

    MOV AL, False

    Fin:

  END;

  FUNCTION TomaInterrupcion (Indice : Byte) : Pointer; ASSEMBLER;
  ASM
    MOV AH, FuncionTomaInterrupcion
    MOV AL, Indice
    INT InterrupcionDOS
    MOV DX, ES
    MOV AX, BX
  END;

  PROCEDURE PoneInterrupcion (Indice : Byte; Direccion : Pointer); ASSEMBLER;
  ASM
    PUSH DS
    MOV AH, FuncionPoneInterrupcion
    MOV AL, Indice
    LDS DX, Direccion
    INT InterrupcionDOS
    POP DS
  END;

BEGIN
  Error := 0;
  TomaVersion (VersionMayor, VersionMenor);

  IF VersionMayor < 4 THEN
  BEGIN
    Error := 1;
  END;

END.